-- bucher.lua
-- Created on:  2020-10-17
-- Author:      Rétro
-- 
-- Tests pour tortues RSI
--
rsiT = require("rsiTurtle")
rsiB = require("bucher")
rsiE = require("excaver")

rsiT.helloWorld()

print("Test de RSI_Turtle")
t = rsiT:init()
t:print()

print("Test de RSI_Bucheron")
b = rsiB:init()
b:print()

print("Test de RSI_Excavatrice")
e = rsiE:init()
e:print()

-- print("Test de l'API turtle")
-- print(turtle.inspect())
-- print(turtle.up())
-- 
-- print("Test RSI_Turtle:facing(3)")
-- print(t:face(3))
-- t:print()
-- print("Test RSI_Turtle:facing(6)")
-- print(t:face(6))
-- t:print()
-- print("Test RSI_Turtle:facing(9)")
-- print(t:face(9))
-- t:print()
-- print("Test RSI_Turtle:facing(12)")
-- print(t:face(12))
-- t:print()
-- 
-- t:face(6)
-- t:print()
-- t:face(12)
-- t:print()
-- t:face(9)
-- t:print()
-- 
-- print("Test mouvements;")
-- t:face(6)
-- t:forward()
-- t:up()
-- t:print()
-- t:backward()
-- t:down()
-- t:print()
-- 
-- print("Test ground();")
-- t:ground()

-- print("Test move;")
-- print("1;")
-- t:move(0,0,5)
-- print("2;")
-- t:move(-3,-2,5)
-- print("3;")
-- t:move(2,2)
-- t:ground()

-- print("Test moveForward;")
-- t:moveForward(5)

-- print("Test moveBackward;")
-- t:moveBackward(5)

function checkPos(x,y,z)
    xPos, yPos, zPos = t:getPos()
    return ( xPos == x and yPos == y and zPos == z )
end

-- print("Tests face;")
-- for i=0,9,3
-- do
--     for j=0,9,3
--     do
--         t:face(i)
--         assert(t.facing_ == 0
--         t
--     end
-- end

print("Tests moveTo;")
assert(t:moveToOrigin())
print(t:getPos())
assert(checkPos(0,0,0))

assert(t:moveTo2D(5,0))
print(t:getPos())
assert(checkPos(5,0,0))

assert(t:moveToOrigin())
print(t:getPos())
assert(checkPos(0,0,0))

print("Tests problematiques")
assert(t:moveTo2D(0, 5))
print(t:getPos())
assert(checkPos(0,0,5))

assert(t:moveTo2D(0,-5))
print(t:getPos())
assert(checkPos(0,0,-5))

assert(t:moveToOrigin())
print(t:getPos())
assert(checkPos(0,0,0))

assert(t:moveTo(10,2,-1))
print(t:getPos())
assert(checkPos(10,2,-1))

assert(t:moveTo(-5,5,5))
print(t:getPos())
assert(checkPos(-5,5,5))

assert(t:moveToOrigin())
print(t:getPos())
assert(checkPos(0,0,0))
t:face(12)

print("Fin des tests")

